/*

 * Delivered to the U.S. Government in Accordance with Contract FA8650-10-C-7080.

 *

 * EXPORT CONTROLLED

 * ECCN#   EAR99

 * Warning: This document contains technical data which is controlled under the

 * Bureau of Industry & Security's Export Administration Regulations and may not be

 * exported or re-exported without authorization by the Bureau of Industry & Security.

 * Diversion contrary to US law is prohibited.

 *

 * (c) 2011 United Technologies Corp.

 * Developed with the sponsorship of the Defense Advanced Research Projects Agency (DARPA).

 *

 * Permission is hereby granted, free of charge, to any person obtaining a copy of this data,

 * including any software or models in source or binary form, as well as any drawings, 

 * specifications, and documentation (collectively "the Data"), to deal in the Data without 

 * restriction, including without limitation the rights to use, copy, modify, merge, publish,

 * distribute, sublicense, and/or sell copies of the Data, and to permit persons to whom the Data

 * is furnished to do so, subject to the following conditions:

 * 

 * The above copyright notice and this permission notice shall be included in all copies or

 * substantial portions of the Data.

 *

 * THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING

 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND

 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR

 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION

 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE DATA OR THE

 * USE OR OTHER DEALINGS IN THE DATA.

*/



package aee.engine.rule;



import java.util.List;



import org.jdom.Attribute;

import org.jdom.Element;



import aee.engine.TypedObject;

import aee.exception.AeeException;





/**

 * A term in a design rule operation

 */

public class Term extends TypedObject {

	private TermType type;

	private String   value;

	private static final String ElementName = "term";

	

	/**

	 * Constructor

	 * @param root  The element

	 * @throws AeeException if any unexpected XML errors detected

	 */

	@SuppressWarnings("unchecked")

	public Term(Element root) throws AeeException {

		super(root, ElementName);

		

		type  = null;

		value = null;



		// type attribute is optional. value is required

		List<Attribute> attributes = root.getAttributes();

		for (Attribute attribute : attributes) {

			String attName = attribute.getName();

			String val     = attribute.getValue().trim();

			

			if (attName.equalsIgnoreCase("type")) {

				try {

					type = TermType.parse(val);

				} catch (Exception ex) {

					throw new AeeException(ex);

				}

			

			} else if (attName.equalsIgnoreCase("value"))	{

				if (! "".equals(val))

					value = val;

				

			} else {

				throw new AeeException("Unrecognized %s attribute in %s element",

						                   attName, ElementName);

			}

		}

		

		if (type == null)

			type = TermType.Premise;

		

		if (value == null)

			throw new AeeException("Missing value for %s element", ElementName);

	}

	

	/**

	 * Report the term's type

	 * @return The type

	 */

	public TermType getType() {

		return type;

	}

	

	/**

	 * Report the term's value

	 * @return The value

	 */

	public String getValue() {

		return value;

	}

	

	/**

	 * Report the term as an external string

	 * @return Array of all term elements

	 */

	public String[] toExternalString() {

		return (getType() == TermType.Premise)? new String[]{                      getValue()}

		                                      : new String[]{getType().toString(), getValue()};

	}

}

